Code

4bd986f43091715432bb4b740cfe4f0e0701cf85
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
9 done,*)
10         # do not redirect again
11         ;;
12 *' --tee '*|*' --va'*)
13         mkdir -p test-results
14         BASE=test-results/$(basename "$0" .sh)
15         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16          echo $? > $BASE.exit) | tee $BASE.out
17         test "$(cat $BASE.exit)" = 0
18         exit
19         ;;
20 esac
22 # Keep the original TERM for say_color
23 ORIGINAL_TERM=$TERM
25 # For repeatability, reset the environment to known value.
26 LANG=C
27 LC_ALL=C
28 PAGER=cat
29 TZ=UTC
30 TERM=dumb
31 export LANG LC_ALL PAGER TERM TZ
32 EDITOR=:
33 VISUAL=:
34 unset GIT_EDITOR
35 unset AUTHOR_DATE
36 unset AUTHOR_EMAIL
37 unset AUTHOR_NAME
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
40 unset EMAIL
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42 unset GIT_AUTHOR_DATE
43 GIT_AUTHOR_EMAIL=author@example.com
44 GIT_AUTHOR_NAME='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL=committer@example.com
47 GIT_COMMITTER_NAME='C O Mitter'
48 unset GIT_DIFF_OPTS
49 unset GIT_DIR
50 unset GIT_WORK_TREE
51 unset GIT_EXTERNAL_DIFF
52 unset GIT_INDEX_FILE
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
57 GIT_MERGE_VERBOSITY=5
58 export GIT_MERGE_VERBOSITY
59 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
60 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
61 export EDITOR VISUAL
62 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
64 # Protect ourselves from common misconfiguration to export
65 # CDPATH into the environment
66 unset CDPATH
68 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
69         1|2|true)
70                 echo "* warning: Some tests will not work if GIT_TRACE" \
71                         "is set as to trace on STDERR ! *"
72                 echo "* warning: Please set GIT_TRACE to something" \
73                         "other than 1, 2 or true ! *"
74                 ;;
75 esac
77 # Each test should start with something like this, after copyright notices:
78 #
79 # test_description='Description of this test...
80 # This test checks if command xyzzy does the right thing...
81 # '
82 # . ./test-lib.sh
83 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
84                 TERM=$ORIGINAL_TERM &&
85                 export TERM &&
86                 [ -t 1 ] &&
87                 tput bold >/dev/null 2>&1 &&
88                 tput setaf 1 >/dev/null 2>&1 &&
89                 tput sgr0 >/dev/null 2>&1
90         ) &&
91         color=t
93 while test "$#" -ne 0
94 do
95         case "$1" in
96         -d|--d|--de|--deb|--debu|--debug)
97                 debug=t; shift ;;
98         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
99                 immediate=t; shift ;;
100         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
101                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
102         -h|--h|--he|--hel|--help)
103                 help=t; shift ;;
104         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
105                 verbose=t; shift ;;
106         -q|--q|--qu|--qui|--quie|--quiet)
107                 quiet=t; shift ;;
108         --no-color)
109                 color=; shift ;;
110         --no-python)
111                 # noop now...
112                 shift ;;
113         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
114                 valgrind=t; verbose=t; shift ;;
115         --tee)
116                 shift ;; # was handled already
117         *)
118                 break ;;
119         esac
120 done
122 if test -n "$color"; then
123         say_color () {
124                 (
125                 TERM=$ORIGINAL_TERM
126                 export TERM
127                 case "$1" in
128                         error) tput bold; tput setaf 1;; # bold red
129                         skip)  tput bold; tput setaf 2;; # bold green
130                         pass)  tput setaf 2;;            # green
131                         info)  tput setaf 3;;            # brown
132                         *) test -n "$quiet" && return;;
133                 esac
134                 shift
135                 printf "* %s" "$*"
136                 tput sgr0
137                 echo
138                 )
139         }
140 else
141         say_color() {
142                 test -z "$1" && test -n "$quiet" && return
143                 shift
144                 echo "* $*"
145         }
146 fi
148 error () {
149         say_color error "error: $*"
150         trap - EXIT
151         exit 1
154 say () {
155         say_color info "$*"
158 test "${test_description}" != "" ||
159 error "Test script did not set test_description."
161 if test "$help" = "t"
162 then
163         echo "$test_description"
164         exit 0
165 fi
167 exec 5>&1
168 if test "$verbose" = "t"
169 then
170         exec 4>&2 3>&1
171 else
172         exec 4>/dev/null 3>/dev/null
173 fi
175 test_failure=0
176 test_count=0
177 test_fixed=0
178 test_broken=0
179 test_success=0
181 die () {
182         echo >&5 "FATAL: Unexpected exit with code $?"
183         exit 1
186 trap 'die' EXIT
188 # The semantics of the editor variables are that of invoking
189 # sh -c "$EDITOR \"$@\"" files ...
191 # If our trash directory contains shell metacharacters, they will be
192 # interpreted if we just set $EDITOR directly, so do a little dance with
193 # environment variables to work around this.
195 # In particular, quoting isn't enough, as the path may contain the same quote
196 # that we're using.
197 test_set_editor () {
198         FAKE_EDITOR="$1"
199         export FAKE_EDITOR
200         VISUAL='"$FAKE_EDITOR"'
201         export VISUAL
204 test_tick () {
205         if test -z "${test_tick+set}"
206         then
207                 test_tick=1112911993
208         else
209                 test_tick=$(($test_tick + 60))
210         fi
211         GIT_COMMITTER_DATE="$test_tick -0700"
212         GIT_AUTHOR_DATE="$test_tick -0700"
213         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
216 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
218 # This will commit a file with the given contents and the given commit
219 # message.  It will also add a tag with <message> as name.
221 # Both <file> and <contents> default to <message>.
223 test_commit () {
224         file=${2:-"$1.t"}
225         echo "${3-$1}" > "$file" &&
226         git add "$file" &&
227         test_tick &&
228         git commit -m "$1" &&
229         git tag "$1"
232 # Call test_merge with the arguments "<message> <commit>", where <commit>
233 # can be a tag pointing to the commit-to-merge.
235 test_merge () {
236         test_tick &&
237         git merge -m "$1" "$2" &&
238         git tag "$1"
241 # This function helps systems where core.filemode=false is set.
242 # Use it instead of plain 'chmod +x' to set or unset the executable bit
243 # of a file in the working directory and add it to the index.
245 test_chmod () {
246         chmod "$@" &&
247         git update-index --add "--chmod=$@"
250 # Use test_set_prereq to tell that a particular prerequisite is available.
251 # The prerequisite can later be checked for in two ways:
253 # - Explicitly using test_have_prereq.
255 # - Implicitly by specifying the prerequisite tag in the calls to
256 #   test_expect_{success,failure,code}.
258 # The single parameter is the prerequisite tag (a simple word, in all
259 # capital letters by convention).
261 test_set_prereq () {
262         satisfied="$satisfied$1 "
264 satisfied=" "
266 test_have_prereq () {
267         case $satisfied in
268         *" $1 "*)
269                 : yes, have it ;;
270         *)
271                 ! : nope ;;
272         esac
275 # You are not expected to call test_ok_ and test_failure_ directly, use
276 # the text_expect_* functions instead.
278 test_ok_ () {
279         test_success=$(($test_success + 1))
280         say_color "" "  ok $test_count: $@"
283 test_failure_ () {
284         test_failure=$(($test_failure + 1))
285         say_color error "FAIL $test_count: $1"
286         shift
287         echo "$@" | sed -e 's/^/        /'
288         test "$immediate" = "" || { trap - EXIT; exit 1; }
291 test_known_broken_ok_ () {
292         test_fixed=$(($test_fixed+1))
293         say_color "" "  FIXED $test_count: $@"
296 test_known_broken_failure_ () {
297         test_broken=$(($test_broken+1))
298         say_color skip "  still broken $test_count: $@"
301 test_debug () {
302         test "$debug" = "" || eval "$1"
305 test_run_ () {
306         eval >&3 2>&4 "$1"
307         eval_ret="$?"
308         return 0
311 test_skip () {
312         test_count=$(($test_count+1))
313         to_skip=
314         for skp in $GIT_SKIP_TESTS
315         do
316                 case $this_test.$test_count in
317                 $skp)
318                         to_skip=t
319                 esac
320         done
321         if test -z "$to_skip" && test -n "$prereq" &&
322            ! test_have_prereq "$prereq"
323         then
324                 to_skip=t
325         fi
326         case "$to_skip" in
327         t)
328                 say_color skip >&3 "skipping test: $@"
329                 say_color skip "skip $test_count: $1"
330                 : true
331                 ;;
332         *)
333                 false
334                 ;;
335         esac
338 test_expect_failure () {
339         test "$#" = 3 && { prereq=$1; shift; } || prereq=
340         test "$#" = 2 ||
341         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
342         if ! test_skip "$@"
343         then
344                 say >&3 "checking known breakage: $2"
345                 test_run_ "$2"
346                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
347                 then
348                         test_known_broken_ok_ "$1"
349                 else
350                     test_known_broken_failure_ "$1"
351                 fi
352         fi
353         echo >&3 ""
356 test_expect_success () {
357         test "$#" = 3 && { prereq=$1; shift; } || prereq=
358         test "$#" = 2 ||
359         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
360         if ! test_skip "$@"
361         then
362                 say >&3 "expecting success: $2"
363                 test_run_ "$2"
364                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
365                 then
366                         test_ok_ "$1"
367                 else
368                         test_failure_ "$@"
369                 fi
370         fi
371         echo >&3 ""
374 test_expect_code () {
375         test "$#" = 4 && { prereq=$1; shift; } || prereq=
376         test "$#" = 3 ||
377         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
378         if ! test_skip "$@"
379         then
380                 say >&3 "expecting exit code $1: $3"
381                 test_run_ "$3"
382                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
383                 then
384                         test_ok_ "$2"
385                 else
386                         test_failure_ "$@"
387                 fi
388         fi
389         echo >&3 ""
392 # test_external runs external test scripts that provide continuous
393 # test output about their progress, and succeeds/fails on
394 # zero/non-zero exit code.  It outputs the test output on stdout even
395 # in non-verbose mode, and announces the external script with "* run
396 # <n>: ..." before running it.  When providing relative paths, keep in
397 # mind that all scripts run in "trash directory".
398 # Usage: test_external description command arguments...
399 # Example: test_external 'Perl API' perl ../path/to/test.pl
400 test_external () {
401         test "$#" = 4 && { prereq=$1; shift; } || prereq=
402         test "$#" = 3 ||
403         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
404         descr="$1"
405         shift
406         if ! test_skip "$descr" "$@"
407         then
408                 # Announce the script to reduce confusion about the
409                 # test output that follows.
410                 say_color "" " run $test_count: $descr ($*)"
411                 # Run command; redirect its stderr to &4 as in
412                 # test_run_, but keep its stdout on our stdout even in
413                 # non-verbose mode.
414                 "$@" 2>&4
415                 if [ "$?" = 0 ]
416                 then
417                         test_ok_ "$descr"
418                 else
419                         test_failure_ "$descr" "$@"
420                 fi
421         fi
424 # Like test_external, but in addition tests that the command generated
425 # no output on stderr.
426 test_external_without_stderr () {
427         # The temporary file has no (and must have no) security
428         # implications.
429         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
430         stderr="$tmp/git-external-stderr.$$.tmp"
431         test_external "$@" 4> "$stderr"
432         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
433         descr="no stderr: $1"
434         shift
435         say >&3 "expecting no stderr from previous command"
436         if [ ! -s "$stderr" ]; then
437                 rm "$stderr"
438                 test_ok_ "$descr"
439         else
440                 if [ "$verbose" = t ]; then
441                         output=`echo; echo Stderr is:; cat "$stderr"`
442                 else
443                         output=
444                 fi
445                 # rm first in case test_failure exits.
446                 rm "$stderr"
447                 test_failure_ "$descr" "$@" "$output"
448         fi
451 # This is not among top-level (test_expect_success | test_expect_failure)
452 # but is a prefix that can be used in the test script, like:
454 #       test_expect_success 'complain and die' '
455 #           do something &&
456 #           do something else &&
457 #           test_must_fail git checkout ../outerspace
458 #       '
460 # Writing this as "! git checkout ../outerspace" is wrong, because
461 # the failure could be due to a segv.  We want a controlled failure.
463 test_must_fail () {
464         "$@"
465         test $? -gt 0 -a $? -le 129 -o $? -gt 192
468 # test_cmp is a helper function to compare actual and expected output.
469 # You can use it like:
471 #       test_expect_success 'foo works' '
472 #               echo expected >expected &&
473 #               foo >actual &&
474 #               test_cmp expected actual
475 #       '
477 # This could be written as either "cmp" or "diff -u", but:
478 # - cmp's output is not nearly as easy to read as diff -u
479 # - not all diff versions understand "-u"
481 test_cmp() {
482         $GIT_TEST_CMP "$@"
485 # Most tests can use the created repository, but some may need to create more.
486 # Usage: test_create_repo <directory>
487 test_create_repo () {
488         test "$#" = 1 ||
489         error "bug in the test script: not 1 parameter to test-create-repo"
490         owd=`pwd`
491         repo="$1"
492         mkdir -p "$repo"
493         cd "$repo" || error "Cannot setup test environment"
494         "$GIT_EXEC_PATH/git-init" "--template=$owd/../templates/blt/" >&3 2>&4 ||
495         error "cannot run git init -- have you built things yet?"
496         mv .git/hooks .git/hooks-disabled
497         cd "$owd"
500 test_done () {
501         trap - EXIT
502         test_results_dir="$TEST_DIRECTORY/test-results"
503         mkdir -p "$test_results_dir"
504         test_results_path="$test_results_dir/${0%.sh}-$$"
506         echo "total $test_count" >> $test_results_path
507         echo "success $test_success" >> $test_results_path
508         echo "fixed $test_fixed" >> $test_results_path
509         echo "broken $test_broken" >> $test_results_path
510         echo "failed $test_failure" >> $test_results_path
511         echo "" >> $test_results_path
513         if test "$test_fixed" != 0
514         then
515                 say_color pass "fixed $test_fixed known breakage(s)"
516         fi
517         if test "$test_broken" != 0
518         then
519                 say_color error "still have $test_broken known breakage(s)"
520                 msg="remaining $(($test_count-$test_broken)) test(s)"
521         else
522                 msg="$test_count test(s)"
523         fi
524         case "$test_failure" in
525         0)
526                 say_color pass "passed all $msg"
528                 test -d "$remove_trash" &&
529                 cd "$(dirname "$remove_trash")" &&
530                 rm -rf "$(basename "$remove_trash")"
532                 exit 0 ;;
534         *)
535                 say_color error "failed $test_failure among $msg"
536                 exit 1 ;;
538         esac
541 # Test the binaries we have just built.  The tests are kept in
542 # t/ subdirectory and are run in 'trash directory' subdirectory.
543 TEST_DIRECTORY=$(pwd)
544 if test -z "$valgrind"
545 then
546         if test -z "$GIT_TEST_INSTALLED"
547         then
548                 PATH=$TEST_DIRECTORY/..:$PATH
549                 GIT_EXEC_PATH=$TEST_DIRECTORY/..
550         else
551                 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
552                 error "Cannot run git from $GIT_TEST_INSTALLED."
553                 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
554                 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
555         fi
556 else
557         make_symlink () {
558                 test -h "$2" &&
559                 test "$1" = "$(readlink "$2")" || {
560                         # be super paranoid
561                         if mkdir "$2".lock
562                         then
563                                 rm -f "$2" &&
564                                 ln -s "$1" "$2" &&
565                                 rm -r "$2".lock
566                         else
567                                 while test -d "$2".lock
568                                 do
569                                         say "Waiting for lock on $2."
570                                         sleep 1
571                                 done
572                         fi
573                 }
574         }
576         make_valgrind_symlink () {
577                 # handle only executables
578                 test -x "$1" || return
580                 base=$(basename "$1")
581                 symlink_target=$TEST_DIRECTORY/../$base
582                 # do not override scripts
583                 if test -x "$symlink_target" &&
584                     test ! -d "$symlink_target" &&
585                     test "#!" != "$(head -c 2 < "$symlink_target")"
586                 then
587                         symlink_target=../valgrind.sh
588                 fi
589                 case "$base" in
590                 *.sh|*.perl)
591                         symlink_target=../unprocessed-script
592                 esac
593                 # create the link, or replace it if it is out of date
594                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
595         }
597         # override all git executables in TEST_DIRECTORY/..
598         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
599         mkdir -p "$GIT_VALGRIND"/bin
600         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
601         do
602                 make_valgrind_symlink $file
603         done
604         OLDIFS=$IFS
605         IFS=:
606         for path in $PATH
607         do
608                 ls "$path"/git-* 2> /dev/null |
609                 while read file
610                 do
611                         make_valgrind_symlink "$file"
612                 done
613         done
614         IFS=$OLDIFS
615         PATH=$GIT_VALGRIND/bin:$PATH
616         GIT_EXEC_PATH=$GIT_VALGRIND/bin
617         export GIT_VALGRIND
618 fi
619 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
620 unset GIT_CONFIG
621 GIT_CONFIG_NOSYSTEM=1
622 GIT_CONFIG_NOGLOBAL=1
623 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
625 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
626 export GITPERLLIB
627 test -d ../templates/blt || {
628         error "You haven't built things yet, have you?"
631 if ! test -x ../test-chmtime; then
632         echo >&2 'You need to build test-chmtime:'
633         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
634         exit 1
635 fi
637 . ../GIT-BUILD-OPTIONS
639 # Test repository
640 test="trash directory.$(basename "$0" .sh)"
641 test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
642 rm -fr "$test" || {
643         trap - EXIT
644         echo >&5 "FATAL: Cannot prepare test area"
645         exit 1
648 test_create_repo "$test"
649 # Use -P to resolve symlinks in our working directory so that the cwd
650 # in subprocesses like git equals our $PWD (for pathname comparisons).
651 cd -P "$test" || exit 1
653 this_test=${0##*/}
654 this_test=${this_test%%-*}
655 for skp in $GIT_SKIP_TESTS
656 do
657         to_skip=
658         for skp in $GIT_SKIP_TESTS
659         do
660                 case "$this_test" in
661                 $skp)
662                         to_skip=t
663                 esac
664         done
665         case "$to_skip" in
666         t)
667                 say_color skip >&3 "skipping test $this_test altogether"
668                 say_color skip "skip all tests in $this_test"
669                 test_done
670         esac
671 done
673 # Fix some commands on Windows
674 case $(uname -s) in
675 *MINGW*)
676         # Windows has its own (incompatible) sort and find
677         sort () {
678                 /usr/bin/sort "$@"
679         }
680         find () {
681                 /usr/bin/find "$@"
682         }
683         sum () {
684                 md5sum "$@"
685         }
686         # git sees Windows-style pwd
687         pwd () {
688                 builtin pwd -W
689         }
690         # no POSIX permissions
691         # backslashes in pathspec are converted to '/'
692         # exec does not inherit the PID
693         ;;
694 *)
695         test_set_prereq POSIXPERM
696         test_set_prereq BSLASHPSPEC
697         test_set_prereq EXECKEEPSPID
698         ;;
699 esac
701 test -z "$NO_PERL" && test_set_prereq PERL
703 # test whether the filesystem supports symbolic links
704 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
705 rm -f y